<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSpecialReqDetailsTypeOtherServiceInformation
 * ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfSpecialReqDetailsTypeOtherServiceInformation extends AbstractStructArrayBase
{
    /**
     * The OtherServiceInformation
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgOtherServiceInformation[]
     */
    public $OtherServiceInformation;
    /**
     * Constructor method for ArrayOfSpecialReqDetailsTypeOtherServiceInformation
     * @uses DgArrayOfSpecialReqDetailsTypeOtherServiceInformation::setOtherServiceInformation()
     * @param \dgsoft\StructType\DgOtherServiceInformation[] $otherServiceInformation
     */
    public function __construct(array $otherServiceInformation = array())
    {
        $this
            ->setOtherServiceInformation($otherServiceInformation);
    }
    /**
     * Get OtherServiceInformation value
     * @return \dgsoft\StructType\DgOtherServiceInformation[]|null
     */
    public function getOtherServiceInformation()
    {
        return $this->OtherServiceInformation;
    }
    /**
     * Set OtherServiceInformation value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgOtherServiceInformation[] $otherServiceInformation
     * @return \dgsoft\ArrayType\DgArrayOfSpecialReqDetailsTypeOtherServiceInformation
     */
    public function setOtherServiceInformation(array $otherServiceInformation = array())
    {
        foreach ($otherServiceInformation as $arrayOfSpecialReqDetailsTypeOtherServiceInformationOtherServiceInformationItem) {
            // validation for constraint: itemType
            if (!$arrayOfSpecialReqDetailsTypeOtherServiceInformationOtherServiceInformationItem instanceof \dgsoft\StructType\DgOtherServiceInformation) {
                throw new \InvalidArgumentException(sprintf('The OtherServiceInformation property can only contain items of \dgsoft\StructType\DgOtherServiceInformation, "%s" given', is_object($arrayOfSpecialReqDetailsTypeOtherServiceInformationOtherServiceInformationItem) ? get_class($arrayOfSpecialReqDetailsTypeOtherServiceInformationOtherServiceInformationItem) : gettype($arrayOfSpecialReqDetailsTypeOtherServiceInformationOtherServiceInformationItem)), __LINE__);
            }
        }
        $this->OtherServiceInformation = $otherServiceInformation;
        return $this;
    }
    /**
     * Add item to OtherServiceInformation value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgOtherServiceInformation $item
     * @return \dgsoft\ArrayType\DgArrayOfSpecialReqDetailsTypeOtherServiceInformation
     */
    public function addToOtherServiceInformation(\dgsoft\StructType\DgOtherServiceInformation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgOtherServiceInformation) {
            throw new \InvalidArgumentException(sprintf('The OtherServiceInformation property can only contain items of \dgsoft\StructType\DgOtherServiceInformation, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->OtherServiceInformation[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgOtherServiceInformation|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgOtherServiceInformation|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgOtherServiceInformation|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgOtherServiceInformation|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgOtherServiceInformation|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OtherServiceInformation
     */
    public function getAttributeName()
    {
        return 'OtherServiceInformation';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfSpecialReqDetailsTypeOtherServiceInformation
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
